// mdScratchModulu.js

(function(ext) {
    var device = null;
    var _rxBuf = [];

    // Sensor states:
    var ports = {
        Port1: 1,
        Port2: 2,
        Port3: 15,
        Port4: 4,
        Port5: 5,
        Port6: 6,
        Port7: 7,
        Port8: 8,
		Port9: 9,
        Port10: 10,
		M1:9,
		M2:10
    };
	var slots = {
		Slot1:1,
		Slot2:2
	};
	var switchStatus = {
		On:1,
		Off:0
	};
	var durums = {
		YAK:1,
		SÖNDÜR:0
	};
	var leds = {
		"1. Ledi": 		7,
		"2. Ledi": 		9,
		"MAVİ Ledi": 	3,
		"YEŞİL Ledi": 	5,
		"KIRMIZI Ledi": 6,
		"3. Ledi": 		10,
		"4. Ledi": 		12
	};
	var pwmLeds = {
		"2. Ledin":		9,
		"3. Ledin":		10
	};	
	var renks = {
		"KIRMIZI": 		0,
		"YEŞİL": 		1,
		"MAVİ": 		2,
		"SARI": 		3,
		"TURUNCU": 		4,
		"MOR": 			5,
		"PEMBE": 		6,
		"TURKUAZ": 		7,
		"BEYAZ": 		8
	};
	var sess = {
		ÇAL:1,
		SUSTUR:0
	};
	var butons = {
		"1. Buton":		2,
		"2. Buton":		4
	}
	var olays = {
		"Basılı":		1,
		"Basılı Değil":	0
	}
	
	var axis = {
		'X-Axis':1,
		'Y-Axis':2,
		'Z-Axis':3
	}
	var tones ={"B0":31,"C1":33,"D1":37,"E1":41,"F1":44,"G1":49,"A1":55,"B1":62,
			"C2":65,"D2":73,"E2":82,"F2":87,"G2":98,"A2":110,"B2":123,
			"C3":131,"D3":147,"E3":165,"F3":175,"G3":196,"A3":220,"B3":247,
			"C4":262,"D4":294,"E4":330,"F4":349,"G4":392,"A4":440,"B4":494,
			"C5":523,"D5":587,"E5":659,"F5":698,"G5":784,"A5":880,"B5":988,
			"C6":1047,"D6":1175,"E6":1319,"F6":1397,"G6":1568,"A6":1760,"B6":1976,
			"C7":2093,"D7":2349,"E7":2637,"F7":2794,"G7":3136,"A7":3520,"B7":3951,
			"C8":4186,"D8":4699};
	var beats = {"Half":500,"Quarter":250,"Eighth":125,"Whole":1000,"Double":2000,"Zero":0};
	var values = {};
	var indexs = [];
	
	var startTimer = 0;
	var versionIndex = 0xFA;
    ext.resetAll = function(){
    	device.send([0xff, 0x55, 2, 0, 4]);
    };
	
	ext.runArduino = function(){
		responseValue();
	};
	ext.scratchCalistir = function(led,durum) {
        runPackage(30,typeof led=="string"?leds[led]:new Number(led),typeof durum=="string"?durums[durum]:new Number(durum));
    };
	ext.scratchCal = function(ses) {
        runPackage(30,11,typeof ses=="string"?sess[ses]:new Number(ses));
    };	
	ext.scratchGoster = function(rakam) {
        switch(rakam)
		{
			case 0:
			{
				runPackage(30,7,1);
				runPackage(30,9,1);
				runPackage(30,3,1);
				runPackage(30,5,1);
				runPackage(30,6,1);
				runPackage(30,10,1);
				runPackage(30,12,0);
			}
			break;
			case 1:
			{
				runPackage(30,7,0);
				runPackage(30,9,1);
				runPackage(30,3,1);
				runPackage(30,5,0);
				runPackage(30,6,0);
				runPackage(30,10,0);
				runPackage(30,12,0);
			}
			break;
			case 2:
			{
				runPackage(30,7,1);
				runPackage(30,9,1);
				runPackage(30,3,0);
				runPackage(30,5,1);
				runPackage(30,6,1);
				runPackage(30,10,0);
				runPackage(30,12,1);
			}
			break;
			case 3:
			{
				runPackage(30,7,1);
				runPackage(30,9,1);
				runPackage(30,3,1);
				runPackage(30,5,1);
				runPackage(30,6,0);
				runPackage(30,10,0);
				runPackage(30,12,1);
			}
			break;
			case 4:
			{
				runPackage(30,7,0);
				runPackage(30,9,1);
				runPackage(30,3,1);
				runPackage(30,5,0);
				runPackage(30,6,0);
				runPackage(30,10,1);
				runPackage(30,12,1);
			}
			break;
			case 5:
			{
				runPackage(30,7,1);
				runPackage(30,9,0);
				runPackage(30,3,1);
				runPackage(30,5,1);
				runPackage(30,6,0);
				runPackage(30,10,1);
				runPackage(30,12,1);
			}
			break;
			case 6:
			{
				runPackage(30,7,1);
				runPackage(30,9,0);
				runPackage(30,3,1);
				runPackage(30,5,1);
				runPackage(30,6,1);
				runPackage(30,10,1);
				runPackage(30,12,1);
			}
			break;
			case 7:
			{
				runPackage(30,7,1);
				runPackage(30,9,1);
				runPackage(30,3,1);
				runPackage(30,5,0);
				runPackage(30,6,0);
				runPackage(30,10,0);
				runPackage(30,12,0);
			}
			break;
			case 8:
			{
				runPackage(30,7,1);
				runPackage(30,9,1);
				runPackage(30,3,1);
				runPackage(30,5,1);
				runPackage(30,6,1);
				runPackage(30,10,1);
				runPackage(30,12,1);
			}
			break;
			case 9:
			{
				runPackage(30,7,1);
				runPackage(30,9,1);
				runPackage(30,3,1);
				runPackage(30,5,1);
				runPackage(30,6,0);
				runPackage(30,10,1);
				runPackage(30,12,1);
			}
			break;
		}
    };	
    ext.scratchPwmLedCalistir = function(pwmLed,pwmDurum) {
        runPackage(32,typeof pwmLed=="string"?pwmLeds[pwmLed]:new Number(pwmLed),pwmDurum);
    };
	ext.scratchRGBLedCalistir = function(renk) {
        switch(typeof renk=="number"?renk:renks[renk])
		{
			case 0:	/* KIRMIZI */
			{
				runPackage(32,3,0);
				runPackage(32,5,0);
				runPackage(32,6,255);
			}
			break;
			case 1:	/* YEŞİL */
			{
				runPackage(32,3,0);
				runPackage(32,5,255);
				runPackage(32,6,0);
			}
			break;
			case 2:	/* MAVİ */
			{
				runPackage(32,3,255);
				runPackage(32,5,0);
				runPackage(32,6,0);
			}
			break;
			case 3:	/* SARI */
			{
				runPackage(32,3,0);
				runPackage(32,5,75);
				runPackage(32,6,235);
			}
			break;
			case 4:	/* TURUNCU */
			{
				runPackage(32,3,0);
				runPackage(32,5,25);
				runPackage(32,6,255);
			}
			break;
			case 5:	/* MOR */
			{
				runPackage(32,3,200);
				runPackage(32,5,0);
				runPackage(32,6,200);
			}
			break;
			case 6:	/* PEMBE */
			{
				runPackage(32,3,75);
				runPackage(32,5,15);
				runPackage(32,6,225);
			}
			break;
			case 7:	/* TURKUAZ */
			{
				runPackage(32,3,255);
				runPackage(32,5,255);
				runPackage(32,6,150);
			}
			break;
			case 8:	/* BEYAZ */
			{
				runPackage(32,3,255);
				runPackage(32,5,255);
				runPackage(32,6,255);
			}
			break;
		}	
    }; 
    ext.scratchRGBLedKaristir = function(renk1,renk2,renk3) {
        runPackage(32,3,renk3);
		runPackage(32,5,renk2);
		runPackage(32,6,renk1);
    };	
	ext.scratchPwmCal = function(pwmSes) {
        runPackage(32,11,pwmSes);
    };	
	
	
	ext.runTone = function(pin,tone,beat){
		runPackage(34,pin,short2array(typeof tone=="number"?tone:tones[tone]),short2array(typeof beat=="number"?beat:beats[beat]));
	};
	ext.runServoArduino = function(pin, angle){
		runPackage(33,pin,angle);
	};
	ext.resetTimer = function(){
		startTimer = new Date().getTime();
		responseValue();
	};
	
	
	
	ext.scratchOku = function(nextID,buton,olay){
		var deviceId = 30;
		getPackage(nextID,deviceId,typeof buton=="number"?buton:butons[buton],olay=="number"?olay:olays[olay]);
	};
	
	ext.scratchLDROku = function(nextID) {
		var deviceId = 31;
		getPackage(nextID,deviceId);
    };	
	
	ext.scratchTrmptOku = function(nextID) {
		var deviceId = 31;
		getPackage(nextID,deviceId);
    };	

	ext.scratchDhtOku = function(nextID,dhtSecimi){
    	var deviceId = 23;
		if(typeof dhtSecimi=="string"){
			dhtSecimi = ("NEM" == dhtSecimi) ? 0 : 1;
		}
		getPackage(nextID,deviceId,4,dhtSecimi);
	};	
	
	ext.getPulse = function(nextID,pin,timeout) {
		var deviceId = 37;
		getPackage(nextID,deviceId,pin,short2array(timeout));
    };
	ext.getUltrasonicArduino = function(nextID,trig,echo){
		var deviceId = 36;
		getPackage(nextID,deviceId,trig,echo);
	}
	ext.getTimer = function(nextID){
		if(startTimer==0){
			startTimer = new Date().getTime();
		}
		responseValue(nextID,new Date().getTime()-startTimer);
	}

	
	
	
	
/****************************************************************************/	
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/	
	function sendPackage(argList, type){
		var bytes = [0xff, 0x55, 0, 0, type];
		for(var i=0;i<argList.length;++i){
			var val = argList[i];
			if(val.constructor == "[class Array]"){
				bytes = bytes.concat(val);
			}else{
				bytes.push(val);
			}
		}
		bytes[2] = bytes.length - 3;
		device.send(bytes);
	}
	
	function runPackage(){
		sendPackage(arguments, 2);
	}
	function getPackage(){
		var nextID = arguments[0];
		Array.prototype.shift.call(arguments);
		sendPackage(arguments, 1);
	}

    var inputArray = [];
	var _isParseStart = false;
	var _isParseStartIndex = 0;
    function processData(bytes) {
		var len = bytes.length;
		if(_rxBuf.length>30){
			_rxBuf = [];
		}
		for(var index=0;index<bytes.length;index++){
			var c = bytes[index];
			_rxBuf.push(c);
			if(_rxBuf.length>=2){
				if(_rxBuf[_rxBuf.length-1]==0x55 && _rxBuf[_rxBuf.length-2]==0xff){
					_isParseStart = true;
					_isParseStartIndex = _rxBuf.length-2;
				}
				if(_rxBuf[_rxBuf.length-1]==0xa && _rxBuf[_rxBuf.length-2]==0xd&&_isParseStart){
					_isParseStart = false;
					
					var position = _isParseStartIndex+2;
					var extId = _rxBuf[position];
					position++;
					var type = _rxBuf[position];
					position++;
					//1 byte 2 float 3 short 4 len+string 5 double
					var value;
					switch(type){
						case 1:{
							value = _rxBuf[position];
							position++;
						}
							break;
						case 2:{
							value = readFloat(_rxBuf,position);
							position+=4;
							if(value<-255||value>1023){
								value = 0;
							}
						}
							break;
						case 3:{
							value = readInt(_rxBuf,position,2);
							position+=2;
						}
							break;
						case 4:{
							var l = _rxBuf[position];
							position++;
							value = readString(_rxBuf,position,l);
						}
							break;
						case 5:{
							value = readDouble(_rxBuf,position);
							position+=4;
						}
							break;
						case 6:
							value = readInt(_rxBuf,position,4);
							position+=4;
							break;
					}
					if(type<=6){
						responseValue(extId,value);
					}else{
						responseValue();
					}
					_rxBuf = [];
				}
			} 
		}
    }
	function readFloat(arr,position){
		var f= [arr[position],arr[position+1],arr[position+2],arr[position+3]];
		return parseFloat(f);
	}
	function readInt(arr,position,count){
		var result = 0;
		for(var i=0; i<count; ++i){
			result |= arr[position+i] << (i << 3);
		}
		return result;
	}
	function readDouble(arr,position){
		return readFloat(arr,position);
	}
	function readString(arr,position,len){
		var value = "";
		for(var ii=0;ii<len;ii++){
			value += String.fromCharCode(_rxBuf[ii+position]);
		}
		return value;
	}
    function appendBuffer( buffer1, buffer2 ) {
        return buffer1.concat( buffer2 );
    }

    // Extension API interactions
    var potentialDevices = [];
    ext._deviceConnected = function(dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    }

    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    }

    var watchdog = null;
    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        device.set_receive_handler('arduino',processData);
    };

    ext._deviceRemoved = function(dev) {
        if(device != dev) return;
        device = null;
    };

    ext._shutdown = function() {
        if(device) device.close();
        device = null;
    };

    ext._getStatus = function() {
        if(!device) return {status: 1, msg: 'Arduino disconnected'};
        if(watchdog) return {status: 1, msg: 'Probing for Arduino'};
        return {status: 2, msg: 'Arduino connected'};
    }

    var descriptor = {};
	ScratchExtensions.register('ONburda Scratch Modülü', descriptor, ext, {type: 'serial'});
})({});
